<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
	<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
	<TITLE>Multi-Tape Turing Machine</TITLE>
	<META NAME="GENERATOR" CONTENT="OpenOffice.org 1.1.5  (Linux)">
	<META NAME="CREATED" CONTENT="20070619;13205700">
	<META NAME="CHANGED" CONTENT="20070709;14494900">
</HEAD>
<BODY LANG="en-US" DIR="LTR">
<P STYLE="margin-bottom: 0in"><FONT SIZE=6><B>Multi-Tape Turing
Machines</B></FONT></P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in">Contents</H2>
<P STYLE="margin-bottom: 0in"><A HREF="#introduction"><U>Introduction</U></A><A HREF="#blocks"><U><BR></U></A><A HREF="#how to"><U>How
to Create an Multi-Tape Turing Machine</U></A></P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="introduction"></A>
Introduction</H2>
<P STYLE="margin-bottom: 0in">It is recommended, if you haven't
already, to read the tutorial about <A HREF="../one/index.html">creating
a one-tape Turing machine</A>. It covers much of the basics about
Turing machines and how their displays are different from other
automata. 
</P>
<P STYLE="margin-bottom: 0in">Multi-tape Turing machines as
implemented in JFLAP are Turing machines ranging from 2 to 5 tapes.
Values on both tapes must match for the automaton to proceed, but
other than that, there isn't much difference between the two modes.
Multi-tape Turing machines allow for a number of languages to be
implemented with greater ease. One such example is the language
demonstrated in the one tape tutorial, <I>L</I> = {<I>a<SUP>n</SUP>b<SUP>n</SUP>c<SUP>n</SUP></I>}.
We will build this example with 3 tapes and test it.</P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="how to"></A>How
to Create a Multi-Tape Turing Machine</H2>
<P STYLE="margin-bottom: 0in">To start a new multi-tape Turing
machine, start JFLAP and click the M<B>ulti-Tape Turing Machine</B>
option from the menu, as shown below:</P>
<P ALIGN=CENTER><IMG SRC="images/mainmenu" NAME="Graphic1" ALIGN=MIDDLE WIDTH=233 HEIGHT=321 BORDER=0></P>
<P STYLE="margin-bottom: 0in">A pop-up window will come up asking how
many tapes to implement, 2 is the default, but from the menu given,
we can choose a number in the range of 2 to 5. While we could
definitely do this problem with 1 or 2 tapes, choose 3 tapes, because
it allows for us to implement an automaton that is very easy to
understand visually. After choosing 3 tapes, one will see a screen
that is identical to that for one-tape Turing machines. However,
there are a few different features that we will soon encounter. 
</P>
<P STYLE="margin-bottom: 0in">On the blank screen, add 5 states to
the screen, so that the screen resembles the one below.</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/addedstates" NAME="Graphic3" ALIGN=BOTTOM WIDTH=600 HEIGHT=435 BORDER=0></P>
<P STYLE="margin-bottom: 0in">Now its time to add the transitions.
Attempt to add a transition between the states q0 and q1. You'll
notice that, instead of just one tape that you have to define values
for, you must define values for three tapes. Go ahead and enter in
(b; b, R) for the first tape, (□; □, S) for the second, and □;
b, R) for the third. This transition will check to see if there is a
'b' under the head of the first tape, and if there are blanks under
the heads of the other two tapes.  If this is true, then it will add
a 'b' to the third tape, move the heads of the first and third tapes
to the right, and not move the head of the second tape.</P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<CENTER>
	<TABLE CELLPADDING=2 CELLSPACING=2>
		<TR>
			<TH>
				<P><U>Three tapes </U>
				</P>
			</TH>
			<TH>
				<P><U>The first transition</U></P>
			</TH>
		</TR>
		<TR>
			<TD>
				<P>.<IMG SRC="images/newtransition" NAME="Graphic4" ALIGN=MIDDLE WIDTH=225 HEIGHT=48 BORDER=0></P>
			</TD>
			<TD>
				<P><IMG SRC="images/addedfirsttransition" NAME="Graphic5" ALIGN=MIDDLE WIDTH=412 HEIGHT=138 BORDER=0></P>
			</TD>
		</TR>
	</TABLE>
</CENTER>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Let's finish up the
transitions. Add the transitions in your screen below to your Turing
machine. If you would rather not add every transition directly and
would prefer to load the file of the screen below, it is available at
<A HREF="turingAnBnCnMulti.jff">turingAnBnCnMulti.jff</A>.</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/finishedtransitions" NAME="Graphic6" ALIGN=MIDDLE WIDTH=600 HEIGHT=435 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Now, let's try out our new
multi-tape Turing machine. We could do a “Fast Run”, but since we
haven't done a “Step” option yet for Turing machines, let's try
that. It is very similar to the “Step with Closure” option for
Finite Automata. First, click on “Input” and then “Step”, and
when it prompts for the values for the three tapes, enter the string
“aabbcc” on the first tape (representing <I>a<SUP>2</SUP>b<SUP>2</SUP>c<SUP>2</SUP></I>)
and nothing on the next two tapes. We now see the screen below...</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/runintro" NAME="Graphic2" ALIGN=MIDDLE WIDTH=600 HEIGHT=435 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">The box in the lower left is
different from that which appears for the Finite Automata's “Step
with Closure” option. In this example, each tape is present, and a
red highlighted area represents the current position of the tape's
head. A similar screen will appear for any number of Turing machine
tapes, with one tape for single-tape machines and five for five tape
machines (all viewable with the scroll bar at the lower right). At
present, the third tape is partially obscured, so we should scroll
down until it is more visible or resize the window.  Which ever
option you choose, make sure you can see all three tapes.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">As we press step repeatedly,
the following are the steps through which the simulation runs:</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<CENTER>
	<TABLE BORDER=0 CELLPADDING=2 CELLSPACING=0>
		<COL WIDTH=148>
		<COL WIDTH=145>
		<COL WIDTH=146>
		<COL WIDTH=0>
		<COL WIDTH=0>
		<TR>
			<TH WIDTH=148>
				<P><U>Start</U></P>
			</TH>
			<TH WIDTH=145>
				<P><U>Step 1</U></P>
			</TH>
			<TH WIDTH=146>
				<P><U>Step 2</U></P>
			</TH>
			<TH>
				<P><U>Step 3</U></P>
			</TH>
			<TH>
				<P><U>Step 4</U></P>
			</TH>
		</TR>
		<TR>
			<TD WIDTH=148>
				<P><IMG SRC="images/runstep0" NAME="Graphic8" ALIGN=MIDDLE WIDTH=143 HEIGHT=98 BORDER=0>
								</P>
			</TD>
			<TD WIDTH=145>
				<P><IMG SRC="images/runstep1" NAME="Graphic10" ALIGN=MIDDLE WIDTH=143 HEIGHT=98 BORDER=0></P>
			</TD>
			<TD WIDTH=146>
				<P><IMG SRC="images/runstep2" NAME="Graphic7" ALIGN=MIDDLE WIDTH=143 HEIGHT=98 BORDER=0></P>
			</TD>
			<TD>
				<P><IMG SRC="images/runstep3" NAME="Graphic9" ALIGN=MIDDLE WIDTH=143 HEIGHT=98 BORDER=0></P>
			</TD>
			<TD>
				<P><IMG SRC="images/runstep4" NAME="Graphic9" ALIGN=MIDDLE WIDTH=143 HEIGHT=98 BORDER=0></P>
			</TD>
		</TR>
	</TABLE>
</CENTER>
<CENTER>
	<TABLE BORDER=0 CELLPADDING=2 CELLSPACING=0>
		<COL WIDTH=148>
		<COL WIDTH=145>
		<COL WIDTH=146>
		<COL WIDTH=0>
		<TR>
			<TH WIDTH=148>
				<P><U>Step 5</U></P>
			</TH>
			<TH WIDTH=145>
				<P><U>Step 6</U></P>
			</TH>
			<TH WIDTH=146>
				<P><U>Step 7</U></P>
			</TH>
			<TH>
				<P><U>Success!</U></P>
			</TH>
		</TR>
		<TR>
			<TD WIDTH=148>
				<P><IMG SRC="images/runstep5" NAME="Graphic8" ALIGN=MIDDLE WIDTH=143 HEIGHT=98 BORDER=0>
								</P>
			</TD>
			<TD WIDTH=145>
				<P><IMG SRC="images/runstep6" NAME="Graphic10" ALIGN=MIDDLE WIDTH=143 HEIGHT=98 BORDER=0></P>
			</TD>
			<TD WIDTH=146>
				<P><IMG SRC="images/runstep7" NAME="Graphic7" ALIGN=MIDDLE WIDTH=143 HEIGHT=98 BORDER=0></P>
			</TD>
			<TD>
				<P><IMG SRC="images/runsuccess" NAME="Graphic9" ALIGN=MIDDLE WIDTH=143 HEIGHT=98 BORDER=0></P>
			</TD>
		</TR>
	</TABLE>
</CENTER>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">We now see firsthand how the
algorithm works and how it is implemented in action. First, the first
tape reads all the 'a's and copies them onto the second tape. Then,
it reads all the 'b's and copies them onto the third tape. Finally,
all three tapes check to see whether the number of 'a's, 'b's, and
'c's are equal, the first tape checking the 'c's, the second the
'a's, and the third the 'b's. We might wonder where state “q4”
comes into this, but transitions leading to and from it simply check
where n = 0, which cannot be served by the other transitions.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><B>This concludes our brief
tutorial on building multi-tape Turing machines. Thanks for reading!</B></P>
</BODY>
</HTML>
